<?php

namespace Ulmus\Ldap\Entity;

use Ulmus\Ldap\Entity\Field\{ Datetime };

use Ulmus\Attribute\Property\{Field, Filter, Relation, Virtual};

use Ulmus\EntityCollection;
use Ulmus\Ldap\Attribute\Obj\ObjectClass;
use Ulmus\Ldap\Repository;
use Ulmus\Repository\RepositoryInterface;

#[ObjectClass("group")]
class Group
{
    use \Ulmus\Ldap\EntityTrait;

    #[Field]
    public string $samaccountname;

    #[Field]
    public string $name;

    #[Field]
    public string $description;

    #[Field]
    public string $canonicalName;

    #[Field(name: "objectGUID")]
    public string $guid;

    # You will need to override this method in your entity because an adapter needs to be set for the User entity.
    #[Relation(type: Relation\RelationTypeEnum::oneToMany, key: 'dn', foreignKey: "memberOf", entity: User::class)]
    public EntityCollection $members;

    public function __toString() : string
    {
        return $this->name;
    }
}